#!/bin/bash
#$ -S /bin/sh
#$ -N demo-cluster-job
#$ -cwd
source /etc/profile.d/modules.sh
module load modules modules-init modules-gs modules-noble
module load fftw gmp mpfr gcc
#module load gmtk
module load python/2.6.1
module load lmutil/10.8.5
module load matlab/2008b
#module load python/2.5.4

prediction_task=1
#dataset_name="CB513.fasta"
#dataset_name="CULLEDPDB_PC20_RES2.5_R1.fasta_min_40_max_10000"
dataset_name="CULLEDPDB_SS_TORSION_PC20_RES2.5_R1.fasta"
n_lines_per_protein=4
pssm_window_size=10
ss_window_size=5
n_dim=20
aa_profile_weight_opt_flag=0
diag_cov_weight_opt_flag=2
aa_profile_weight_default=0.5
diag_cov_weight_default=0.01
sparsity_percentage_total=0
sparsity_percentage_per_EM_it=1.0
em_slow_down_weight=0.0

./runall $prediction_task $dataset_name $n_lines_per_protein $pssm_window_size $ss_window_size $n_dim $aa_profile_weight_opt_flag $diag_cov_weight_opt_flag $aa_profile_weight_default $diag_cov_weight_default $sparsity_percentage_total $sparsity_percentage_per_EM_it $em_slow_down_weight

