% -------------------------------------------------------------------------
% change_state : This variable indicates whether a new secondary structure segment 
% is going to appear at the next frame or the current one will be extended. 
% In frame0, this variable is simply initialized to TRUE


variable: change_state {
	type: discrete observed 22:22 cardinality BINARY_CARD;
	switchingparents: nil;	
	conditionalparents: state_count_down(0) using DenseCPT("Fi_given_Di_CPT");
}

 % -------------------------------------------------------------------------
    % state : this variable indicates what state we are currently in ...
    % in frame0, the state will be chosen based on the probability of
    % _starting_ in a particular state

variable: state {
        type: discrete observed 20:20 cardinality STATE_CARD;
        switchingparents: nil;
        conditionalparents: nil using DenseCPT("start_state_CPT");
}

variable: state_count_down {
	type: discrete observed 21:21 cardinality MAX_STATE_LENGTH_CARD;
	switchingparents: nil;
	conditionalparents: state(0) using DenseCPT("start_length_CPT");	
}


variable: state_class_history {
        type: discrete hidden cardinality STATE_CLASS_HISTORY_CARD;
        switchingparents: nil;        
	conditionalparents: state(0) using DeterministicCPT("start_history_CPT");
}

variable: aa_profile {
	type: continuous observed 0:19;
	weight: scale WEIGHT_AA_PROFILE;
	switchingparents: nil;
	conditionalparents: state_class_history(0) using mixture collection("ECcollection") mapping("1D_map");
}

