__author__ = "Zafer Aydin"
__date__ = "11/11/2009"
__project__ = "Protein Structure Prediction"

usage = """

	Usage: python generate_fastas_list_file.py <test postp files list filename> <fastas list filename> 
"""

import sys

if __name__ == "__main__":

	if (len(sys.argv) != 3):

		sys.stderr.write(usage)
		sys.exit(-1)

	test_postp_file_list_filename = sys.argv[1]
	fastas_list_filename = sys.argv[2]

	test_postp_file_list_file = open(test_postp_file_list_filename, 'r')
	fastas_list_file = open(fastas_list_filename, 'w')

	for line in test_postp_file_list_file:

		if ('nc.test.postp.sigmoid' in line):
			line_to_write = line.replace('nc.test.postp.sigmoid', 'fasta')

                elif ('cn.test.postp.sigmoid' in line):
                        line_to_write = line.replace('cn.test.postp.sigmoid', 'fasta')

                elif ('test.postp.sigmoid' in line):
                        line_to_write = line.replace('test.postp.sigmoid', 'fasta')

		elif ('nc.test.postp.linear' in line):
			line_to_write = line.replace('nc.test.postp.linear', 'fasta')

                elif ('cn.test.postp.linear' in line):
                        line_to_write = line.replace('cn.test.postp.linear', 'fasta')

                elif ('test.postp.linear' in line):
                        line_to_write = line.replace('test.postp.linear', 'fasta')

		fastas_list_file.write(line_to_write)

	test_postp_file_list_file.close()
	fastas_list_file.close()
