__author__ = "Zafer Aydin"
__date__ = "11/12/2009"
__project__ = "Protein Structure Prediction"

usage="""

	Usage: generate_initial_means_covars_dlink_matrices3.py <number of Gaussian components> <number of dimensions> <init_covariance> <starting_index> <output filename> <pssm window size>
"""
 
import sys
import random
import math

if __name__ == "__main__":

	if ( len(sys.argv) != 7 ):

		sys.stderr.write(usage)
		sys.exit(-1)

	n_gc = int(sys.argv[1])
	n_dimensions = int(sys.argv[2])
	init_covariance = float(sys.argv[3])
	starting_index = int(sys.argv[4])
	output_filename = sys.argv[5]
	pssm_window_size = int(sys.argv[6])

	output_file = open(output_filename, 'w')

	output_file2 = open('means_covariances.txt', 'w')

	#Generate initial mean vectors
	output_file.write('%d' %n_gc)
        output_file.write('\n\n')

        for i in range(n_gc):

                output_file.write('  ')
                output_file.write('%d' % i)
                output_file.write('   ')
                output_file.write('meanEC')
                output_file.write(str(i))
                output_file.write('    ')
                output_file.write('%d' % n_dimensions)

                for j in range(n_dimensions):

                        output_file.write('   ')
                        #a_random_value = random.normalvariate(0,0.2/3.0)
                        a_random_value = random.uniform(0,1.0)
			#a_random_value = 0.0 

			#initial_mean_value = mean_vectors[i][j] + a_random_value*math.sqrt(diag_covariance_vectors[i][j])
                        initial_mean_value = a_random_value
			output_file.write('%.15f' % initial_mean_value)
			
                output_file.write('\n')

	output_file.write('\n')

	#Generate initial diagonal entries of covariance matrix
        output_file.write('%d' %n_gc)
        output_file.write('\n\n')

        for i in range(n_gc):

                output_file.write('  ')
                output_file.write('%d' % i)
                output_file.write('   ')
                output_file.write('covarEC')
                output_file.write(str(i))
                output_file.write('    ')
                output_file.write('%d' % n_dimensions)

                for j in range(n_dimensions):

                        output_file.write('   ')

			#initial_covariance_value = diag_covariance_vectors[i][j]
                        initial_covariance_value = 10.0
			output_file.write('%.15f' % initial_covariance_value)

                output_file.write('\n')

	output_file.write('\n')

	#Generate initial dlink matrices
	output_file.write('%d' %n_gc)
	output_file.write('\n')

	for i in range(n_gc):

		output_file.write('%d' % i)
		output_file.write('\n')
		output_file.write('dlink_mat')
		output_file.write('%d' % i)
		output_file.write('\n')
		output_file.write('dlink_str' + str(i))
		output_file.write('\n')
		output_file.write('%d' % n_dimensions)
		output_file.write('\n')

		for j in range(n_dimensions):

			n_dependencies = starting_index - j
			output_file.write('%d' % n_dependencies)
			output_file.write('  ')

			for k in range(n_dependencies):

				output_file.write('%.1f' % 0.0)
				output_file.write(' ')

			output_file.write('\n')

		output_file.write('\n')
	
	output_file.close()
	output_file2.close() 
