__author__ = "Zafer Aydin"
__date__ = "11/24/2009"
__project__ = "Protein Structure Prediction"

usage="""

	python prepare_common_params_file.py <models_dir> <binary card value> <triple card value> <state card value> <max state length card value> <state class history card value> <weight_parameter>
"""

import sys

if __name__ == "__main__":

	if (len(sys.argv) != 8):

		sys.stderr.write(usage)
		sys.exit(-1) 

	models_dir=sys.argv[1]
	binary_card = int(sys.argv[2])
	triple_card = int(sys.argv[3])
	state_card = int(sys.argv[4])
	max_state_length_card = int(sys.argv[5])
	state_class_history_card = int(sys.argv[6])
	weight_value = float(sys.argv[7])

	common_params_filename = models_dir + 'common_params.txt'
	common_params_file = open(common_params_filename, 'w')
	common_params_file.write('#ifndef COMMON_PARAMS\n')
	common_params_file.write('#define COMMON_PARAMS\n\n')
	common_params_file.write('#define BINARY_CARD\t\t\t%d\n' % binary_card)
	common_params_file.write('#define TRIPLE_CARD\t\t\t%d\n' % triple_card)
	common_params_file.write('#define STATE_CARD\t\t\t%d\n' % state_card)
	common_params_file.write('#define MAX_STATE_LENGTH_CARD\t\t\t%d\n' % max_state_length_card)
	common_params_file.write('#define STATE_CLASS_HISTORY_CARD\t\t\t%d\n' % state_class_history_card)
	common_params_file.write('#define WEIGHT_AA_PROFILE\t\t\t%s\n' % str(weight_value))
	common_params_file.write('#endif')
	common_params_file.write('\n')
	common_params_file.close()
