__author__ = "Zafer Aydin"
__date__ = "11/25/2009"
__project__ = "Protein Structure Prediction"

usage="""

        Usage: prepare_trifile_for_marginal_posteriors.py <input trifile filename> <output trifile filename> 
"""

import sys

if __name__ == "__main__":

        if ( len(sys.argv) != 3 ):

                sys.stderr.write(usage)
                sys.exit(-1)

	input_filename = sys.argv[1]
	output_filename = sys.argv[2]

	input_file = open(input_filename, 'r')
	input_file_inside = input_file.readlines()
	input_file.close()

	n_lines = len(input_file_inside)

	output_file = open(output_filename, 'w')

	p_partitions_start_index = 0
	c_partitions_start_index = 0
	line_index_to_modify_p_partitions_1 = 0
	line_index_to_modify_p_partitions_2 = 0
	line_index_to_modify_c_partitions_1 = 0
	line_index_to_modify_c_partitions_2 = 0

	for i in range(n_lines):

		line = input_file_inside[i]

		if ("P Partitions Cliques and their weights" in line):

			p_partitions_start_index = i

		if ("C Partitions Cliques and their weights" in line):

			c_partitions_start_index = i

		if (("Maximum clique state space" in line) and (line_index_to_modify_p_partitions_1 == 0)):

			line_index_to_modify_p_partitions_1 = i+2
			line_index_to_modify_p_partitions_2 = i+4

		if (("Maximum clique state space" in line) and (line_index_to_modify_p_partitions_1 != 0) and (line_index_to_modify_c_partitions_1 == 0) and (c_partitions_start_index > 0)):

			line_index_to_modify_c_partitions_1 = i+2
			line_index_to_modify_c_partitions_2 = i+4

		if ((i == line_index_to_modify_p_partitions_1) and (i > p_partitions_start_index)):

			output_file.write('3\n')

		elif ((i == line_index_to_modify_p_partitions_2) and (i > p_partitions_start_index)):

			output_file.write('1  1 state 0\n')
			output_file.write('2  1 state 1\n')
			output_file.write('\n')

		elif ((i == line_index_to_modify_c_partitions_1) and (i > c_partitions_start_index)):

			output_file.write('2\n')

		elif ((i == line_index_to_modify_c_partitions_2) and (i > c_partitions_start_index)):

			output_file.write('1  1 state 2\n')	
			output_file.write('\n')

		else:
			output_file.write(line)
			
	output_file.close()

	

