#!/bin/bash
# FILE: runEM.sh
# AUTHOR: Zafer Aydin
# DATE: 12/31/2009
# PROJECT: Prediction of Structural Labels

if [ $# -ne 14 ]
then
        echo ""
        echo "Usage: $0 <gmtk bins dir> <str_filename> <master_filename_in> <master_filename_out> <train_files_list_filename> <non_trainable_list_filename> <n_continuous_features> <n_discrete_features> <n_skip> <l2_reg_thr_mean> <l2_reg_thr_dlink> <lldp_thr> <var_floor_thr> <max_n_iters>"
        exit 1
fi

gmtk_bins_dir=$1
str_filename=$2
master_filename_in=$3
master_filename_out=$4
train_files_list_filename=$5
non_trainable_list_filename=$6
n_continuous_features=$7
n_discrete_features=$8
n_skip=$9
l2_reg_thr_mean=${10}
l2_reg_thr_dlink=${11}
lldp_thr=${12}
var_floor_thr=${13}
max_n_iters=${14}

${gmtk_bins_dir}gmtkEMtrainNew \
		-strFile $str_filename \
		-of1 $train_files_list_filename -nf1 $n_continuous_features -ni1 $n_discrete_features -fmt1 ascii \
		-inputMasterFile $master_filename_in \
		-outputMasterFile $master_filename_out \
		-dirichletPriors T \
		-maxEmIters $max_n_iters \
		-objsNotToTrain $non_trainable_list_filename \
		-varFloor $var_floor_thr \
		-startSkip $n_skip \
                -gmarCoeffL2 $l2_reg_thr_mean \
		-gdarCoeffL2 $l2_reg_thr_dlink \
		-lldp $lldp_thr \
		-verbosity 19 

