#!/bin/bash

if [ $# -ne 7 ]
then
        echo ""
        echo "Usage: $0 <gmtk bins path> <dataset_dir> <models_dir> <train_files_root> <number_of_profiles_to_skip> <max number of EM iterations>"
        exit 1
fi

gmtk_bins_path=$1
dataset_dir=$2
models_dir=$3
train_files_root=$4
n_skip=$5
reg_param=$6
max_n_iters=$7

#/net/noble/vol2/home/zafer/projects/pssp/gmtk/bin/x86_64/gmtkEMtrainNew \
${gmtk_bins_path}gmtkEMtrainNew \
		-strFile ${models_dir}model_train.str \
		-of1 $dataset_dir$train_files_root.list -nf1 20 -ni1 3 -fmt1 ascii \
		-inputMasterFile ${models_dir}model_train_em_in.master \
		-outputMasterFile ${models_dir}model_train_em_out.master \
		-dirichletPriors T \
		-maxEmIters $max_n_iters \
		-objsNotToTrain ./nonTrainable.list \
		-varFloor 1.e-10 \
		-startSkip $n_skip \
		-gdarCoeffL2 $reg_param \
		-lldp 0.05 \
		-verbosity 19 
#>& ./runEM.log


##============================================================================
