#!/bin/bash

if [ $# -ne 15 ]
then
        echo ""
        echo "Usage: $0 <gmtk_bins_dir> <str_filename> <master_filename_in> <master_filename_out> <non_trainable_list_filename> <train_files_root> <fold_index> <n_continuous_features> <n_discrete_features> <n_skip> <l2_reg_thr_mean> <l2_reg_thr_dlink> <lldp_thr> <varfloor_thr> <max_em_iters>"
        exit 1
fi

gmtk_bins_dir=$1
str_filename=$2
master_filename_in=$3
master_filename_out=$4
train_files_root=$5
non_trainable_list_filename=$6
fold_index=$7
n_continuous_features=$8
n_discrete_features=$9
n_skip=${10}
l2_reg_thr_mean=${11}
l2_reg_thr_dlink=${12}
lldp_thr=${13}
varfloor_thr=${14}
max_em_iters=${15}

#/net/noble/vol2/home/zafer/projects/pssp/gmtk/bin/x86_64/gmtkEMtrainNew \
${gmtk_bins_dir}gmtkEMtrainNew \
                -strFile $str_filename \
                -of1 $train_files_root.$fold_index.list -nf1 $n_continuous_features -ni1 $n_discrete_features -fmt1 ascii \
                -inputMasterFile $master_filename_in \
                -outputMasterFile $master_filename_out \
                -dirichletPriors T \
                -maxEmIters $max_em_iters \
                -objsNotToTrain $non_trainable_list_filename \
                -varFloor $varfloor_thr \
                -startSkip $n_skip \
		-gmarCoeffL2 $l2_reg_thr_mean \
                -gdarCoeffL2 $l2_reg_thr_dlink \
                -lldp $lldp_thr \
                -verbosity 19


