#!/bin/bash

if [ $# -ne 5 ]
then
        echo ""
        echo "Usage: $0 <gmtk bins path> <dataset_dir> <models_dir> <test_files_root> <number_of_profiles_to_skip>"
        echo ""
        exit 1
fi

gmtk_bins_path=$1
dataset_dir=$2
models_dir=$3
test_files_root=$4
n_skip=$5

#/net/noble/vol2/home/zafer/projects/pssp/gmtk/bin/x86_64/gmtkJT \
${gmtk_bins_path}gmtkJT \
		-strFile ${models_dir}model_test.str \
		-triFile ${models_dir}model_test.mytrifile \
		-of1 $dataset_dir$test_files_root.list -nf1 20 -ni1 3 -fmt1 ascii \
		-inputMasterFile ${models_dir}model_test_in.master \
		-pCliquePrintRange 1:2 \
		-cCliquePrintRange 1:1 \
		-doDist \
		-startSkip $n_skip \
		-verbosity 19 


##============================================================================
