#!/bin/bash
# FILE: runJT_yao.sh
# AUTHOR: Zafer Aydin
# DATE: 01/22/2009
# PROJECT: Protein Secondary Structure Prediction

if [ $# -ne 7 ]
then
        echo ""
        echo "Usage: $0 <gmtk bins path> <number_of_cv_folds> <dataset_dir> <models_dir> <test_files_root> <number_of_profiles_to_skip>"
        echo ""
        exit 1
fi

gmtk_bins_path=$1
fold_index=$2
internal_fold_index=$3
dataset_dir=$4
models_dir=$5
test_files_root=$6
n_skip=$7

#gmtkJT \
#/net/noble/vol2/home/zafer/projects/pssp/gmtk/bin/x86_64/gmtkJT \
${gmtk_bins_path}gmtkJT \
		-strFile ${models_dir}model_test.str \
		-triFile ${models_dir}model_test.mytrifile \
		-of1 $dataset_dir$test_files_root$fold_index$internal_fold_index.list -nf1 20 -ni1 3 -fmt1 ascii \
		-inputMasterFile ${models_dir}model_test_in.master \
		-pCliquePrintRange 1:2 \
		-cCliquePrintRange 1:1 \
		-doDist \
		-startSkip $n_skip \
		-verbosity 19 


##============================================================================
