#!/bin/bash
# FILE: runTrainTest2.sh
# AUTHOR: Zafer Aydin
# DATE: 12/31/2009
# PROJECT: Prediction of Structural Labels

if [ $# -ne 62 ]
then
	echo ""
	echo "Usage: $0 <prediction_task> <n_state_classes> <pssm_window_size> <ss_window_size> <aa_profile_weight_opt_flag> <diag_cov_weight_opt_flag> <n_dim> <starting_index> <n_gc> <n_cv_folds> <data_dir> <scripts_dir> <models_dir> <gmtk_dir> <matlab_dir> <fastas_train_filename> <fastas_test_filename> <train_files_root> <test_files_root> <test_postp_files_root> <nc_model_root> <aapw_train_files_root> <aapw_test_files_root> <aapw_test_postp_files_root> <dcw_train_files_root> <dcw_test_files_root> <dcw_test_postp_files_root> <init_cov> <binary_card> <triple_card> <state_card> <max_state_length_card> <state_class_history_card> <aa_profile_weight> <fixed_params_filename> <init_trainable_params_filename> <train_str_filename> <train_master_filename_in> <train_master_filename_out> <non_trainable_list_filename> <test_str_filename> <test_master_filename_in> <tri_filename> <n_continuous_features> <n_discrete_features> <l2_reg_thr_mean> <l2_reg_thr_dlink> <lldp_thr> <var_floor_thr> <learned_means_filename> <learned_diag_covs_filename> <learned_dlinks_filename> <learned_dense_cpts_filename> <diag_cov_weight> <weights_root> <diag_cov_weight_filename> <n_dlinks_removed_root> <sparsity_percentage_total> <sparsity_percentage_per_EM> <em_slow_down_weight> <output_html_root>"
	echo "" 
	exit 1
fi
 
################################################################################

date

prediction_task=$1
n_state_classes=$2
pssm_window_size=$3
ss_window_size=$4
aa_profile_weight_opt_flag=$5
diag_cov_weight_opt_flag=$6
n_dim=$7
starting_index=$8
n_gc=$9
n_cv_folds=${10}
data_dir=${11}
scripts_dir=${12}
models_dir=${13}
gmtk_dir=${14}
matlab_dir=${15}
fastas_train_filename=${16}
fastas_test_filename=${17}
train_files_root=${18}
test_files_root=${19}
test_postp_files_root=${20}
nc_model_root=${21}
cn_model_root=${22}
aapw_train_files_root=${23}
aapw_test_files_root=${24}
aapw_test_postp_files_root=${25}
dcw_train_files_root=${26}
dcw_test_files_root=${27}
dcw_test_postp_files_root=${28}
init_cov=${29}
binary_card=${30}
triple_card=${31}
state_card=${32}
max_state_length_card=${33}
state_class_history_card=${34}
aa_profile_weight=${35}
fixed_params_filename=${36}
init_trainable_params_filename=${37}
train_str_filename=${38}
train_master_filename_in=${39}
train_master_filename_out=${40}
non_trainable_list_filename=${41}
test_str_filename=${42}
test_master_filename_in=${43}
tri_filename=${44}
n_continuous_features=${45}
n_discrete_features=${46}
l2_reg_thr_mean=${47}
l2_reg_thr_dlink=${48}
lldp_thr=${49}
var_floor_thr=${50}
learned_means_filename=${51}
learned_diag_covs_filename=${52}
learned_dlinks_filename=${53}
learned_dense_cpts_filename=${54}
diag_cov_weight=${55}
weights_root=${56}
diag_cov_weight_filename=${57}
n_dlinks_removed_root=${58}
sparsity_percentage_total=${59}
sparsity_percentage_per_EM=${60}
em_slow_down_weight=${61}
output_html_root=${62}

stop_iteration_flag=0

#Do for the forward model

cat $data_dir${train_files_root}.list >& obs_files.list
\mv obs_files.list $data_dir

n_dlinks_rem_filename=${n_dlinks_removed_root}_laa_${pssm_window_size}_lss_${ss_window_size}_perc_${sparsity_percentage_total}_weight_${em_slow_down_weight}
\cp $data_dir$n_dlinks_removed_root ./$n_dlinks_rem_filename

weights_filename=${weights_root}_laa_${pssm_window_size}_lss_${ss_window_size}_perc_${sparsity_percentage_total}_weight_${em_slow_down_weight}
\cp $data_dir$weights_root ./$weights_filename

#echo "number of dlinks removed filename = $n_dlinks_rem_filename"

date
echo $PWD
echo "percentage = $sparsity_percentage_total"

# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# SPARSIFY THE DLINK STRUCTURE (Past Dependency (NC) Model)
		
#echo "Past Dependency (NC) Model..."   

w=1.0

#Change the weight value in the common_params file
#python ${scripts_dir}prepare_common_params_file.py $models_dir $w
python ${scripts_dir}prepare_common_params_file.py $models_dir $binary_card $triple_card $state_card $max_state_length_card $state_class_history_card $aa_profile_weight

python ${scripts_dir}generate_dlink_str_gcs2.py $n_dim $starting_index $n_gc $fixed_params_filename
python ${scripts_dir}generate_initial_means_covars_dlink_matrices_random.py $n_gc $n_dim $init_cov $starting_index $init_trainable_params_filename $pssm_window_size ${data_dir}obs_files.list	
\cp $fixed_params_filename ${fixed_params_filename}_orig
\cp $init_trainable_params_filename ${init_trainable_params_filename}_orig

n_iterations=`echo $sparsity_percentage_total/$sparsity_percentage_per_EM | bc`
#echo "n_iterations = $n_iterations"

for (( iteration_count = 0; iteration_count < n_iterations; iteration_count++))
do
	percentage=`echo $(($iteration_count+1))*$sparsity_percentage_per_EM | bc`
        perc_thr=$sparsity_percentage_per_EM #eliminate this many percentage of dlinks each time

        #echo "total percentage of dlinks eliminated = $percentage"
        #echo "dlink iteration = $iteration_count"
        max_em_iters=1

	${scripts_dir}runEM.sh $gmtk_dir $train_str_filename $train_master_filename_in $train_master_filename_out $data_dir$train_files_root.$nc_model_root.list $non_trainable_list_filename $n_continuous_features $n_discrete_features $pssm_window_size $l2_reg_thr_mean $l2_reg_thr_dlink $lldp_thr $var_floor_thr $max_em_iters >& ./runEM.forward.log

        \cp ${models_dir}$fixed_params_filename ${models_dir}${fixed_params_filename}_pre
        \cp ${models_dir}learnedParams.EM.dlinkMats.out0 ${models_dir}learnedParams.EM.dlinkMats.out
        \cp ${models_dir}learnedParams.EM.covarVecs.out0 ${models_dir}learnedParams.EM.covarVecs.out
        \cp ${models_dir}learnedParams.EM.denseCPTs.out0 ${models_dir}learnedParams.EM.denseCPTs.out
        \cp ${models_dir}learnedParams.EM.meanVecs.out0 ${models_dir}learnedParams.EM.meanVecs.out
        \cp ${models_dir}learnedParams.EM.dlinkMats.out ${models_dir}learnedParams.EM.dlinkMats_orig.out

        \cp ${models_dir}learnedParams.EM.dlinkMats.out ${models_dir}learnedParams.EM.dlinkMats_curr.out
        \cp ${models_dir}learnedParams.EM.covarVecs.out ${models_dir}learnedParams.EM.covarVecs_curr.out
        \cp ${models_dir}learnedParams.EM.meanVecs.out ${models_dir}learnedParams.EM.meanVecs_curr.out

        if [ "$iteration_count" -ge "1" ]
        then
        	python ${scripts_dir}weighted_average_of_means.py ${models_dir}learnedParams.EM.meanVecs_pre.out ${models_dir}learnedParams.EM.meanVecs_curr.out $n_dim $ss_window_size $em_slow_down_weight ${models_dir}learnedParams.EM.meanVecs.out
                python ${scripts_dir}weighted_average_of_covars.py ${models_dir}learnedParams.EM.covarVecs_pre.out ${models_dir}learnedParams.EM.covarVecs_curr.out $n_dim $ss_window_size $em_slow_down_weight ${models_dir}learnedParams.EM.covarVecs.out
                python ${scripts_dir}weighted_average_of_dlinks.py ${models_dir}learnedParams.EM.dlinkMats_pre.out ${models_dir}learnedParams.EM.dlinkMats_curr.out $n_dim $pssm_window_size $ss_window_size $em_slow_down_weight ${models_dir}learnedParams.EM.dlinkMats.out
        fi

        python ${scripts_dir}sparsify_dlink_structure_learned_dlink_values.py $n_dim $starting_index $n_gc ${models_dir}learnedParams.EM.dlinkMats_orig.out $perc_thr $n_dlinks_rem_filename ${fixed_params_filename}_pre $fixed_params_filename learnedParams.EM.dlinkMats.out

        # to be used in slowing down EM
        \cp ${models_dir}learnedParams.EM.dlinkMats.out ${models_dir}learnedParams.EM.dlinkMats_pre.out
        \cp ${models_dir}learnedParams.EM.covarVecs.out ${models_dir}learnedParams.EM.covarVecs_pre.out
        \cp ${models_dir}learnedParams.EM.meanVecs.out ${models_dir}learnedParams.EM.meanVecs_pre.out

        cat ${models_dir}learnedParams.EM.meanVecs.out ${models_dir}learnedParams.EM.covarVecs.out ${models_dir}learnedParams.EM.dlinkMats.out >& $init_trainable_params_filename

        #\cp $init_trainable_params_filename ${init_trainable_params_filename}_$percentage
done

#echo "Done sparcifying dlink structure for past dependency model"
	
\cp $fixed_params_filename ${fixed_params_filename}_past_dep
\cp $init_trainable_params_filename ${init_trainable_params_filename}_past_dep

# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# SPARSIFY THE DLINK STRUCTURE (Future Dependency (CN) Model)

#echo "Future Dependency (CN) Model..."

\cp ${fixed_params_filename}_orig $fixed_params_filename
\cp ${init_trainable_params_filename}_orig $init_trainable_params_filename

n_iterations=`echo $sparsity_percentage_total/$sparsity_percentage_per_EM | bc`
  
for (( iteration_count = 0; iteration_count < n_iterations; iteration_count++))
do 
 
	percentage=`echo $(($iteration_count+1))*$sparsity_percentage_per_EM | bc`
        perc_thr=$sparsity_percentage_per_EM #eliminate this many percentage of dlinks each time
 
        #echo "total percentage of dlinks eliminated = $percentage" 
 
        #echo "dlink iteration = $iteration_count" 
        max_em_iters=1 

	${scripts_dir}runEM.sh $gmtk_dir $train_str_filename $train_master_filename_in $train_master_filename_out $data_dir$train_files_root.$cn_model_root.list $non_trainable_list_filename $n_continuous_features $n_discrete_features $pssm_window_size $l2_reg_thr_mean $l2_reg_thr_dlink $lldp_thr $var_floor_thr $max_em_iters >& ./runEM.reverse.log
 
        \cp ${models_dir}$fixed_params_filename ${models_dir}${fixed_params_filename}_pre
        \cp ${models_dir}learnedParams.EM.dlinkMats.out0 ${models_dir}learnedParams.EM.dlinkMats.out
        \cp ${models_dir}learnedParams.EM.covarVecs.out0 ${models_dir}learnedParams.EM.covarVecs.out
        \cp ${models_dir}learnedParams.EM.denseCPTs.out0 ${models_dir}learnedParams.EM.denseCPTs.out
        \cp ${models_dir}learnedParams.EM.meanVecs.out0 ${models_dir}learnedParams.EM.meanVecs.out
        \cp ${models_dir}learnedParams.EM.dlinkMats.out ${models_dir}learnedParams.EM.dlinkMats_orig.out
 
        \cp ${models_dir}learnedParams.EM.dlinkMats.out ${models_dir}learnedParams.EM.dlinkMats_curr.out
        \cp ${models_dir}learnedParams.EM.covarVecs.out ${models_dir}learnedParams.EM.covarVecs_curr.out
        \cp ${models_dir}learnedParams.EM.meanVecs.out ${models_dir}learnedParams.EM.meanVecs_curr.out
 
        if [ "$iteration_count" -ge "1" ] 
        then 
        	python ${scripts_dir}weighted_average_of_means.py ${models_dir}learnedParams.EM.meanVecs_pre.out ${models_dir}learnedParams.EM.meanVecs_curr.out $n_dim $ss_window_size $em_slow_down_weight ${models_dir}learnedParams.EM.meanVecs.out
                python ${scripts_dir}weighted_average_of_covars.py ${models_dir}learnedParams.EM.covarVecs_pre.out ${models_dir}learnedParams.EM.covarVecs_curr.out $n_dim $ss_window_size $em_slow_down_weight ${models_dir}learnedParams.EM.covarVecs.out
                python ${scripts_dir}weighted_average_of_dlinks.py ${models_dir}learnedParams.EM.dlinkMats_pre.out ${models_dir}learnedParams.EM.dlinkMats_curr.out $n_dim $pssm_window_size $ss_window_size $em_slow_down_weight ${models_dir}learnedParams.EM.dlinkMats.out
	fi

	python ${scripts_dir}sparsify_dlink_structure_learned_dlink_values.py $n_dim $starting_index $n_gc ${models_dir}learnedParams.EM.dlinkMats_orig.out $perc_thr $n_dlinks_rem_filename ${fixed_params_filename}_pre $fixed_params_filename learnedParams.EM.dlinkMats.out

        # to be used in slowing down EM
        \cp ${models_dir}learnedParams.EM.dlinkMats.out ${models_dir}learnedParams.EM.dlinkMats_pre.out
        \cp ${models_dir}learnedParams.EM.covarVecs.out ${models_dir}learnedParams.EM.covarVecs_pre.out
        \cp ${models_dir}learnedParams.EM.meanVecs.out ${models_dir}learnedParams.EM.meanVecs_pre.out
                        
	cat ${models_dir}learnedParams.EM.meanVecs.out ${models_dir}learnedParams.EM.covarVecs.out ${models_dir}learnedParams.EM.dlinkMats.out >& $init_trainable_params_filename

        #\cp $init_trainable_params_filename ${init_trainable_params_filename}_$percentage
done

#echo "Done sparcifying dlink structure for future dependency model"
         
\cp $fixed_params_filename ${fixed_params_filename}_fut_dep
\cp $init_trainable_params_filename ${init_trainable_params_filename}_fut_dep

if [ "$aa_profile_weight_opt_flag" == "0" ]
then
	w=1.0

elif [ "$aa_profile_weight_opt_flag" == "1" ]
then 
	echo "Weight optimization by internal cross validation is coming soon. Stay with us!"

elif [ "$aa_profile_weight_opt_flag" == "2" ]
then
	#Use user defined weights
	w=0.35 
else			
	echo "Weight optimization flag should be 0, 1 or 2"
fi

# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# TRAIN THE MODEL (PAST DEPENDENCY (NC) MODEL)

echo "Running EM for Past Dependency (NC) model..."
##python ${scripts_dir}prepare_common_params_file.py $models_dir $w
python ${scripts_dir}prepare_common_params_file.py $models_dir $binary_card $triple_card $state_card $max_state_length_card $state_class_history_card $w
\cp ${fixed_params_filename}_past_dep $fixed_params_filename 
\cp ${init_trainable_params_filename}_past_dep $init_trainable_params_filename

max_em_iters=5
#${scripts_dir}runEM.sh $gmtk_dir $train_str_filename $train_master_filename_in $train_master_filename_out $data_dir$train_files_root.$nc_model_root.list $non_trainable_list_filename $n_continuous_features $n_discrete_features $pssm_window_size $l2_reg_thr_mean $l2_reg_thr_dlink $lldp_thr $var_floor_thr $max_em_iters >& ./runEM.forward.log

#\cp ${models_dir}$learned_means_filename ${models_dir}$learned_means_filename.past
#\cp ${models_dir}$learned_diag_covs_filename ${models_dir}$learned_diag_covs_filename.past
#\cp ${models_dir}$learned_dlinks_filename ${models_dir}$learned_dlinks_filename.past
#\cp ${models_dir}$learned_dense_cpts_filename ${models_dir}$learned_dense_cpts_filename.past

if [ "$diag_cov_weight_opt_flag" == "0" ]
then
        #Don't add any diagonal covariance component to the full covariance matrix
        diag_cov_weight_opt_flag=0

elif [ "$diag_cov_weight_opt_flag" == "1" ]
then
        #Do shrinkage by optimizing the diagonal covariance weight via cross-validation on training set

	forward_reverse_string="forward"

	#${scripts_dir}optimize_diag_cov_weight.sh $prediction_task $data_dir $models_dir $scripts_dir $gmtk_dir $matlab_dir $train_str_filename $train_master_filename_in $train_master_filename_out $non_trainable_list_filename $test_str_filename $tri_filename $test_master_filename_in $dcw_train_files_root.$nc_model_root $dcw_test_files_root.$nc_model_root $dcw_test_postp_files_root.$nc_model_root $fastas_train_filename $n_cv_folds $n_state_classes $pssm_window_size $n_continuous_features $n_discrete_features $n_gc $l2_reg_thr_mean $l2_reg_thr_dlink $lldp_thr $var_floor_thr $max_em_iters $learned_means_filename $learned_diag_covs_filename $learned_dlinks_filename $learned_dense_cpts_filename $diag_cov_weight_filename $forward_reverse_string 

	#Read the optimized weight value from file
	
	#diag_cov_weight=`cat $diag_cov_weight_filename`

	#\cp ${models_dir}$learned_means_filename.past ${models_dir}$learned_means_filename
	#\cp ${models_dir}$learned_diag_covs_filename.past ${models_dir}$learned_diag_covs_filename
	#\cp ${models_dir}$learned_dlinks_filename.past ${models_dir}$learned_dlinks_filename
	#\cp ${models_dir}$learned_dense_cpts_filename.past ${models_dir}$learned_dense_cpts_filename

	#Add the diagonal covariance component with optimized weight
        #if ${matlabdir}matlab -nodisplay -nojvm -r \
        # "add_diagonal_covariance_component_in_full_cov_form('${models_dir}$learned_means_filename', '${models_dir}$learned_diag_covs_filename', '${models_dir}$learned_dlinks_filename', '$n_gc', '$n_dim', '$pssm_window_size', '$diag_cov_weight'); exit"
	#then
        #        echo "Added a diagonal covariance component to the full convariance form"
        #else
        #        echo "[Error] Could not add a diagonal covariance component"
        #        exit 1
        #fi
	
elif [ "$diag_cov_weight_opt_flag" == "2" ]
then
	#Add the diagonal covariance component with a fixed weight

        if ${matlabdir}matlab -nodisplay -nojvm -r \
	 "add_diagonal_covariance_component_in_full_cov_form('${models_dir}$learned_means_filename', '${models_dir}$learned_diag_covs_filename', '${models_dir}$learned_dlinks_filename', '$n_gc', '$n_dim', '$pssm_window_size', '$diag_cov_weight'); exit"
        then
                echo "Added a diagonal covariance component to the full convariance form"
        else
                echo "[Error] Could not add a diagonal covariance component"
                exit 1
        fi
fi

# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# PREDICT ON TEST DATA (PAST DEPENDENCY (NC) MODEL)

#echo "Running JT for Past Dependency (NC) model..."
#${scripts_dir}runJT.sh $gmtk_dir $test_str_filename $tri_filename $test_master_filename_in $data_dir$test_files_root.$nc_model_root.list $n_continuous_features $n_discrete_features $pssm_window_size >& ./runJT.forward.log
#python ${scripts_dir}generate_postp_files.py $n_state_classes $data_dir$test_postp_files_root.list ./runJT.forward.log 

# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# TRAIN THE MODEL (FUTURE DEPENDENCY (CN) MODEL)

echo "Running EM for Future Dependency (CN) model..."
#python ${scripts_dir}prepare_common_params_file.py $models_dir $w               
python ${scripts_dir}prepare_common_params_file.py $models_dir $binary_card $triple_card $state_card $max_state_length_card $state_class_history_card $w
\cp ${fixed_params_filename}_fut_dep $fixed_params_filename 
\cp ${init_trainable_params_filename}_fut_dep $init_trainable_params_filename

max_em_iters=5
${scripts_dir}runEM.sh $gmtk_dir $train_str_filename $train_master_filename_in $train_master_filename_out $data_dir$train_files_root.$cn_model_root.list $non_trainable_list_filename $n_continuous_features $n_discrete_features $pssm_window_size $l2_reg_thr_mean $l2_reg_thr_dlink $lldp_thr $var_floor_thr $max_em_iters >& ./runEM.reverse.log

\cp ${models_dir}$learned_means_filename ${models_dir}$learned_means_filename.fut
\cp ${models_dir}$learned_diag_covs_filename ${models_dir}$learned_diag_covs_filename.fut
\cp ${models_dir}$learned_dlinks_filename ${models_dir}$learned_dlinks_filename.fut
\cp ${models_dir}$learned_dense_cpts_filename ${models_dir}$learned_dense_cpts_filename.fut

if [ "$diag_cov_weight_opt_flag" == "0" ]
then
	#Don't do anything just proceed without adding any diagonal covariance component to the full covariance matrix
	diag_cov_weight_opt_flag=0

elif [ "$diag_cov_weight_opt_flag" == "1" ]
then
        #Do shrinkage by optimizing the diagonal covariance weight via cross-validation on training set

	forward_reverse_string="reverse"

	${scripts_dir}optimize_diag_cov_weight.sh $prediction_task $data_dir $models_dir $scripts_dir $gmtk_dir $matlab_dir $train_str_filename $train_master_filename_in $train_master_filename_out $non_trainable_list_filename $test_str_filename $tri_filename $test_master_filename_in $dcw_train_files_root.$cn_model_root $dcw_test_files_root.$cn_model_root $dcw_test_postp_files_root.$cn_model_root $fastas_train_filename $n_cv_folds $n_state_classes $pssm_window_size $n_continuous_features $n_discrete_features $n_gc $l2_reg_thr_mean $l2_reg_thr_dlink $lldp_thr $var_floor_thr $max_em_iters $learned_means_filename $learned_diag_covs_filename $learned_dlinks_filename $learned_dense_cpts_filename $diag_cov_weight_filename $forward_reverse_string

        #Read the optimized weight value from file
        diag_cov_weight=`cat $diag_cov_weight_filename`

        \cp ${models_dir}$learned_means_filename.fut ${models_dir}$learned_means_filename
        \cp ${models_dir}$learned_diag_covs_filename.fut ${models_dir}$learned_diag_covs_filename
        \cp ${models_dir}$learned_dlinks_filename.fut ${models_dir}$learned_dlinks_filename
        \cp ${models_dir}$learned_dense_cpts_filename.fut ${models_dir}$learned_dense_cpts_filename

        #Add the diagonal covariance component with optimized weight
        if ${matlabdir}matlab -nodisplay -nojvm -r \
         "add_diagonal_covariance_component_in_full_cov_form('${models_dir}$learned_means_filename', '${models_dir}$learned_diag_covs_filename', '${models_dir}$learned_dlinks_filename', '$n_gc', '$n_dim', '$pssm_window_size', '$diag_cov_weight'); exit"
        then
                echo "Added a diagonal covariance component to the full convariance form"
        else
                echo "[Error] Could not add a diagonal covariance component"
                exit 1
        fi

elif [ "$diag_cov_weight_opt_flag" == "2" ]
then
        #Add the diagonal covariance component with a fixed weight

        if ${matlabdir}matlab -nodisplay -nojvm -r \
         "add_diagonal_covariance_component_in_full_cov_form('${models_dir}$learned_means_filename', '${models_dir}$learned_diag_covs_filename', '${models_dir}$learned_dlinks_filename', '$n_gc', '$n_dim', '$pssm_window_size', '$diag_cov_weight'); exit"
        then
                echo "Added a diagonal covariance component to the full convariance form"
        else
                echo "[Error] Could not add a diagonal covariance component"
                exit 1
        fi
fi

# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# PREDICT ON TEST DATA (FUTURE DEPENDENCY (CN) MODEL)

echo "Running JT for Future Dependency (NC) model..."
${scripts_dir}runJT.sh $gmtk_dir $test_str_filename $tri_filename $test_master_filename_in $data_dir$test_files_root.$reverse_model_root.list $n_continuous_features $n_discrete_features $pssm_window_size >& ./runJT.reverse.log
python ${scripts_dir}generate_postp_files.py $n_state_classes $data_dir$test_postp_files_root.$reverse_model_root.list ./runJT.reverse.log

#python ${scripts_dir}generate_fastas_list_file.py $data_dir${test_postp_files_root}_all.list ${data_dir}fastas_all.list

python ${scripts_dir}compute_average_postp_files.py $prediction_task $n_state_classes $data_dir $data_dir$fastas_test_filename ${data_dir}$test_files_root.list $data_dir${test_postp_files_root}.list $data_dir$test_postp_files_root.${reverse_model_root}.list $pssm_window_size 

python ${scripts_dir}compute_accuracy_measures.py $data_dir$fastas_test_filename $n_state_classes $prediction_task $output_html_root 

echo " "
echo " COMPLETELY DONE !!! "
date

################################################################################

