__author__ = "Zafer Aydin"
__date__ = "05/05/2009"

# FILENAME: threshold_dlinks.py
# PROJECT: Protein Secondary Structure Prediction

usage = """

	Usage: python threshold_dlinks.py <dlink matrices filename> <threshold value> <output filename>
"""

import sys

if __name__ == "__main__":


	if (len(sys.argv) != 4):

		sys.stderr.write(usage)
		sys.exit(-1)

	dlink_matrices_filename = sys.argv[1]
	threshold_value = float(sys.argv[2])
	output_filename = sys.argv[3]

	output_file = open(output_filename, 'w')

	dlink_matrices_file = open(dlink_matrices_filename, 'r')

	line1 = dlink_matrices_file.readline()
	line2 = dlink_matrices_file.readline()
	n_dlink_mats_str = dlink_matrices_file.readline()
	n_dlink_mats_str = n_dlink_mats_str.rstrip()
	n_dlink_mats = int(n_dlink_mats_str)

	output_file.write(line1)
	output_file.write(line2)
	output_file.write(n_dlink_mats_str)
	output_file.write('\n')
	
	overall_percentage_dlinks_zeroed = 0
	total_n_dlinks_zeroed = 0
	
	for i in range(n_dlink_mats):

		d_link_index = 	int(dlink_matrices_file.readline().rstrip())
		dlink_mat_name = dlink_matrices_file.readline().rstrip()
		dlink_str_name = dlink_matrices_file.readline().rstrip()
		n_child_nodes = int(dlink_matrices_file.readline().rstrip())
		
		output_file.write('%d\n' % d_link_index)
		output_file.write('%s\n' % dlink_mat_name)
		output_file.write('%s\n' % dlink_str_name)
		output_file.write('%d\n' % n_child_nodes)

		n_dlinks_zeroed = 0
		total_n_edges = 0

		for j in range(n_child_nodes):

			a_line = dlink_matrices_file.readline().rstrip()
			token_list = a_line.split()
			n_edges = int(token_list[0])
			#output_file.write('%d ' % n_edges)
			total_n_edges += n_edges

			n_edges_remaining = 0
			for k in range(n_edges):

                                dlink_value = float(token_list[k+1])

                                if (abs(dlink_value) >= threshold_value):

                                        n_edges_remaining += 1

			output_file.write('%d ' % n_edges_remaining)

			for k in range(n_edges):

				dlink_value = float(token_list[k+1])
				#print dlink_value

				#if (dlink_value < threshold_value):
				if (abs(dlink_value) < threshold_value):
		
					#output_file.write('%f ' % 0.0)
					n_dlinks_zeroed += 1
					total_n_dlinks_zeroed += 1
				else:
					output_file.write('%.15f ' % dlink_value)
				
			output_file.write('\n')
		
		if (total_n_edges != 0):
		
			percentage_dlinks_zeroed = float(n_dlinks_zeroed) / float(total_n_edges)
		else:
			percentage_dlinks_zeroed = 0.0

		#print 'percentage of dlinks zeroed = %f\n' % percentage_dlinks_zeroed
		overall_percentage_dlinks_zeroed += percentage_dlinks_zeroed

	if (n_dlink_mats != 0):
	
		overall_percentage_dlinks_zeroed = float(overall_percentage_dlinks_zeroed) / float(n_dlink_mats)
	else:
		overall_percentage_dlinks_zeroed = 0.0

	#print 'overall percentage of dlinks zeroed = %f\n' % overall_percentage_dlinks_zeroed
	output_file.write('\n')

	output_file.close()
	dlink_matrices_file.close()

	#print 'total number of dlinks zeroed = %d\n' % total_n_dlinks_zeroed
	if (total_n_dlinks_zeroed == 0):

		sys.exit(2)

